Page MenuHomeClusterLabs Projects

No OneTemporary

diff --git a/heartbeat/CTDB.in b/heartbeat/CTDB.in
index d25d026ca..46f56cfac 100755
--- a/heartbeat/CTDB.in
+++ b/heartbeat/CTDB.in
@@ -1,994 +1,996 @@
#!@BASH_SHELL@
#
# OCF Resource Agent for managing CTDB
#
# Copyright (c) 2009-2010 Novell Inc., Tim Serong
# All Rights Reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of version 2 of the GNU General Public License as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it would be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# Further, this software is distributed without any warranty that it is
# free of the rightful claim of any third person regarding infringement
# or the like. Any license provided herein, whether implied or
# otherwise, applies only to this software file. Patent licenses, if
# any, provided herein do not apply to combinations of this program with
# other software, or any other product whatsoever.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
#
#
# OVERVIEW
#
# When run by itself, CTDB can handle IP failover and includes scripts
# to manage various services (Samba, Winbind, HTTP, etc.). When run as
# a resource in a Pacemaker cluster, this additional functionality
# should not be used; instead one should define separate resources for
# CTDB, Samba, Winbind, IP addresses, etc.
#
# As of 2010-11-17, there is no separate OCF Samba or Winbind RA, so
# it is still possible to configure CTDB so that it manages these
# resources itself. In future, once Samba and Winbind RAs are
# available, this ability will be deprecated and ultimately removed.
#
# This RA intentionally provides no ability to configure CTDB such that
# it manages IP failover, HTTP, NFS, etc.
#
#
# TODO:
# - ctdb_stop doesn't really support multiple independent CTDB instances,
# unless they're running from distinct ctdbd binaries (it uses pkill
# $OCF_RESKEY_ctdbd_binary if "ctdb stop" doesn't work, which it might
# not under heavy load - this will kill all ctdbd instances on the
# system). OTOH, running multiple CTDB instances per node is, well,
# AFAIK, completely crazy. Can't run more than one in a vanilla CTDB
# cluster, with the CTDB init script. So it might be nice to address
# this for complete semantic correctness of the RA, but shouldn't
# actually cause any trouble in real life.
# - As much as possible, get rid of auto config generation
# - Especially smb.conf
# - Verify timeouts are sane
# - Monitor differentiate between error and not running?
# - Do we need to verify globally unique setting?
# - Should set CTDB_NODES to ${HA_RSCTMP}/ctdb (generated based on
# current nodes)
# - Look at enabling set_ctdb_variables() if necessary.
# - Probably possible for sysconfig file to not be restored if
# CTDB dies unexpectedly.
#
#######################################################################
# Initialization:
: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
#######################################################################
# Default parameter values:
# Some distro's ctdb package stores the persistent db in /var/lib/ctdb,
# others store in /var/ctdb. This attempts to detect the correct default
# directory.
var_prefix="/var/lib/ctdb"
if [ ! -d "$var_prefix" ] && [ -d "/var/ctdb" ]; then
var_prefix="/var/ctdb"
fi
run_prefix="/run"
if [ ! -d "$var_prefix" ] && [ -d "/var/run" ]; then
var_prefix="/var/run"
fi
# Parameter defaults
OCF_RESKEY_ctdb_recovery_lock_default=""
OCF_RESKEY_ctdb_manages_samba_default="no"
OCF_RESKEY_ctdb_manages_winbind_default="no"
OCF_RESKEY_ctdb_service_smb_default=""
OCF_RESKEY_ctdb_service_nmb_default=""
OCF_RESKEY_ctdb_service_winbind_default=""
OCF_RESKEY_ctdb_samba_skip_share_check_default="yes"
OCF_RESKEY_ctdb_monitor_free_memory_default="100"
OCF_RESKEY_ctdb_start_as_disabled_default="no"
: ${OCF_RESKEY_ctdb_recovery_lock=${OCF_RESKEY_ctdb_recovery_lock_default}}
: ${OCF_RESKEY_ctdb_manages_samba=${OCF_RESKEY_ctdb_manages_samba_default}}
: ${OCF_RESKEY_ctdb_manages_winbind=${OCF_RESKEY_ctdb_manages_winbind_default}}
: ${OCF_RESKEY_ctdb_service_smb=${OCF_RESKEY_ctdb_service_smb_default}}
: ${OCF_RESKEY_ctdb_service_nmb=${OCF_RESKEY_ctdb_service_nmb_default}}
: ${OCF_RESKEY_ctdb_service_winbind=${OCF_RESKEY_ctdb_service_winbind_default}}
: ${OCF_RESKEY_ctdb_samba_skip_share_check=${OCF_RESKEY_ctdb_samba_skip_share_check_default}}
: ${OCF_RESKEY_ctdb_monitor_free_memory=${OCF_RESKEY_ctdb_monitor_free_memory_default}}
: ${OCF_RESKEY_ctdb_start_as_disabled=${OCF_RESKEY_ctdb_start_as_disabled_default}}
OCF_RESKEY_ctdb_config_dir_default="/etc/ctdb"
OCF_RESKEY_ctdb_binary_default="/usr/bin/ctdb"
OCF_RESKEY_ctdbd_binary_default="/usr/sbin/ctdbd"
OCF_RESKEY_ctdb_dbdir_default="${var_prefix}"
OCF_RESKEY_ctdb_logfile_default="/var/log/ctdb/log.ctdb"
OCF_RESKEY_ctdb_rundir_default="${run_prefix}/ctdb"
OCF_RESKEY_ctdb_timeout_default="10"
: ${OCF_RESKEY_ctdb_config_dir=${OCF_RESKEY_ctdb_config_dir_default}}
: ${OCF_RESKEY_ctdb_binary=${OCF_RESKEY_ctdb_binary_default}}
: ${OCF_RESKEY_ctdbd_binary=${OCF_RESKEY_ctdbd_binary_default}}
: ${OCF_RESKEY_ctdb_dbdir=${OCF_RESKEY_ctdb_dbdir_default}}
: ${OCF_RESKEY_ctdb_logfile=${OCF_RESKEY_ctdb_logfile_default}}
: ${OCF_RESKEY_ctdb_rundir=${OCF_RESKEY_ctdb_rundir_default}}
: ${OCF_RESKEY_ctdb_timeout=${OCF_RESKEY_ctdb_timeout_default}}
OCF_RESKEY_ctdb_socket_default="${OCF_RESKEY_ctdb_rundir}/ctdbd.socket"
OCF_RESKEY_ctdb_debuglevel_default="2"
OCF_RESKEY_ctdb_max_open_files_default=""
: ${OCF_RESKEY_ctdb_socket=${OCF_RESKEY_ctdb_socket_default}}
: ${OCF_RESKEY_ctdb_debuglevel=${OCF_RESKEY_ctdb_debuglevel_default}}
: ${OCF_RESKEY_ctdb_max_open_files=${OCF_RESKEY_ctdb_max_open_files_default}}
OCF_RESKEY_smb_conf_default="/etc/samba/smb.conf"
OCF_RESKEY_smb_private_dir_default=""
OCF_RESKEY_smb_passdb_backend_default="tdbsam"
OCF_RESKEY_smb_idmap_backend_default="tdb2"
OCF_RESKEY_smb_fileid_algorithm_default=""
: ${OCF_RESKEY_smb_conf=${OCF_RESKEY_smb_conf_default}}
: ${OCF_RESKEY_smb_private_dir=${OCF_RESKEY_smb_private_dir_default}}
: ${OCF_RESKEY_smb_passdb_backend=${OCF_RESKEY_smb_passdb_backend_default}}
: ${OCF_RESKEY_smb_idmap_backend=${OCF_RESKEY_smb_idmap_backend_default}}
: ${OCF_RESKEY_smb_fileid_algorithm=${OCF_RESKEY_smb_fileid_algorithm_default}}
#######################################################################
ctdb_version() {
$OCF_RESKEY_ctdb_binary version | awk '{print $NF}' | sed "s/[-\.]\?[[:alpha:]].*//"
}
meta_data() {
cat <<END
<?xml version="1.0"?>
<!DOCTYPE resource-agent SYSTEM "ra-api-1.dtd">
<resource-agent name="CTDB" version="1.0">
<version>1.0</version>
<longdesc lang="en">
This resource agent manages CTDB, allowing one to use Clustered Samba in a
Linux-HA/Pacemaker cluster. You need a shared filesystem (e.g. OCFS2 or GFS2) on
which the CTDB lock will be stored. Create /etc/ctdb/nodes containing a list
of private IP addresses of each node in the cluster, then configure this RA
as a clone. This agent expects the samba and windbind resources
to be managed outside of CTDB's control as a separate set of resources controlled
by the cluster manager. The optional support for enabling CTDB management of these
daemons will be depreciated.
For more information see http://linux-ha.org/wiki/CTDB_(resource_agent)
</longdesc>
<shortdesc lang="en">CTDB Resource Agent</shortdesc>
<parameters>
<parameter name="ctdb_recovery_lock" unique="1" required="1">
<longdesc lang="en">
The location of a shared lock file or helper binary, common across all nodes.
See CTDB documentation for details.
</longdesc>
<shortdesc lang="en">CTDB shared lock file</shortdesc>
<content type="string" default="${OCF_RESKEY_ctdb_recovery_lock_default}" />
</parameter>
<parameter name="ctdb_manages_samba" unique="0" required="0">
<longdesc lang="en">
Should CTDB manage starting/stopping the Samba service for you?
This will be deprecated in future, in favor of configuring a
separate Samba resource.
</longdesc>
<shortdesc lang="en">Should CTDB manage Samba?</shortdesc>
<content type="boolean" default="${OCF_RESKEY_ctdb_manages_samba_default}" />
</parameter>
<parameter name="ctdb_manages_winbind" unique="0" required="0">
<longdesc lang="en">
Should CTDB manage starting/stopping the Winbind service for you?
This will be deprecated in future, in favor of configuring a
separate Winbind resource.
</longdesc>
<shortdesc lang="en">Should CTDB manage Winbind?</shortdesc>
<content type="boolean" default="${OCF_RESKEY_ctdb_manages_winbind_default}" />
</parameter>
<parameter name="ctdb_service_smb" unique="0" required="0">
<longdesc lang="en">
Name of smb init script. Only necessary if CTDB is managing
Samba directly. Will usually be auto-detected.
</longdesc>
<shortdesc lang="en">Name of smb init script</shortdesc>
<content type="string" default="${OCF_RESKEY_ctdb_service_smb_default}" />
</parameter>
<parameter name="ctdb_service_nmb" unique="0" required="0">
<longdesc lang="en">
Name of nmb init script. Only necessary if CTDB is managing
Samba directly. Will usually be auto-detected.
</longdesc>
<shortdesc lang="en">Name of nmb init script</shortdesc>
<content type="string" default="${OCF_RESKEY_ctdb_service_nmb_default}" />
</parameter>
<parameter name="ctdb_service_winbind" unique="0" required="0">
<longdesc lang="en">
Name of winbind init script. Only necessary if CTDB is managing
Winbind directly. Will usually be auto-detected.
</longdesc>
<shortdesc lang="en">Name of winbind init script</shortdesc>
<content type="string" default="${OCF_RESKEY_ctdb_service_winbind_default}" />
</parameter>
<parameter name="ctdb_samba_skip_share_check" unique="0" required="0">
<longdesc lang="en">
If there are very many shares it may not be feasible to check that all
of them are available during each monitoring interval. In that case
this check can be disabled.
</longdesc>
<shortdesc lang="en">Skip share check during monitor?</shortdesc>
<content type="boolean" default="${OCF_RESKEY_ctdb_samba_skip_share_check_default}" />
</parameter>
<parameter name="ctdb_monitor_free_memory" unique="0" required="0">
<longdesc lang="en">
If the amount of free memory drops below this value the node will
become unhealthy and ctdb and all managed services will be shutdown.
Once this occurs, the administrator needs to find the reason for the
OOM situation, rectify it and restart ctdb with "service ctdb start".
With CTDB 4.4.0 and later this parameter is ignored.
</longdesc>
<shortdesc lang="en">Minimum amount of free memory (MB)</shortdesc>
<content type="integer" default="${OCF_RESKEY_ctdb_monitor_free_memory_default}" />
</parameter>
<parameter name="ctdb_start_as_disabled" unique="0" required="0">
<longdesc lang="en">
When set to yes, the CTDB node will start in DISABLED mode and not
host any public ip addresses.
</longdesc>
<shortdesc lang="en">Start CTDB disabled?</shortdesc>
<content type="boolean" default="${OCF_RESKEY_ctdb_start_as_disabled_default}" />
</parameter>
<parameter name="ctdb_config_dir" unique="0" required="0">
<longdesc lang="en">
The directory containing various CTDB configuration files.
The "nodes" and "notify.sh" scripts are expected to be
in this directory.
</longdesc>
<shortdesc lang="en">CTDB config file directory</shortdesc>
<content type="string" default="${OCF_RESKEY_ctdb_config_dir_default}" />
</parameter>
<parameter name="ctdb_binary" unique="0" required="0">
<longdesc lang="en">
Full path to the CTDB binary.
</longdesc>
<shortdesc lang="en">CTDB binary path</shortdesc>
<content type="string" default="${OCF_RESKEY_ctdb_binary_default}" />
</parameter>
<parameter name="ctdbd_binary" unique="0" required="0">
<longdesc lang="en">
Full path to the CTDB cluster daemon binary.
</longdesc>
<shortdesc lang="en">CTDB Daemon binary path</shortdesc>
<content type="string" default="${OCF_RESKEY_ctdbd_binary_default}" />
</parameter>
<parameter name="ctdb_socket" unique="1" required="0">
<longdesc lang="en">
Full path to the domain socket that ctdbd will create, used for
local clients to attach and communicate with the ctdb daemon.
With CTDB 4.9.0 and later the socket path is hardcoded at build
time, so this parameter is ignored.
</longdesc>
<shortdesc lang="en">CTDB socket location (ignored with CTDB 4.9+)</shortdesc>
<content type="string" default="${OCF_RESKEY_ctdb_socket_default}" />
</parameter>
<parameter name="ctdb_dbdir" unique="1" required="0">
<longdesc lang="en">
The directory to put the local CTDB database files in.
Persistent database files will be put in ctdb_dbdir/persistent.
</longdesc>
<shortdesc lang="en">CTDB database directory</shortdesc>
<content type="string" default="${OCF_RESKEY_ctdb_dbdir_default}" />
</parameter>
<parameter name="ctdb_logfile" unique="0" required="0">
<longdesc lang="en">
Full path to log file. To log to syslog instead, use the
value "syslog".
</longdesc>
<shortdesc lang="en">CTDB log file location</shortdesc>
<content type="string" default="${OCF_RESKEY_ctdb_logfile_default}" />
</parameter>
<parameter name="ctdb_rundir" unique="0" required="0">
<longdesc lang="en">
Full path to ctdb runtime directory, used for storage of socket
lock state.
</longdesc>
<shortdesc lang="en">CTDB runtime directory location</shortdesc>
<content type="string" default="${OCF_RESKEY_ctdb_rundir_default}" />
</parameter>
<parameter name="ctdb_timeout" unique="1" required="0">
<longdesc lang="en">
Indicates that ctdb should wait up to TIMEOUT seconds for a response to most commands sent to the CTDB daemon.
</longdesc>
<shortdesc lang="en">CTDB timeout in seconds</shortdesc>
<content type="integer" default="${OCF_RESKEY_ctdb_timeout_default}" />
</parameter>
<parameter name="ctdb_debuglevel" unique="0" required="0">
<longdesc lang="en">
What debug level to run at (0-10). Higher means more verbose.
</longdesc>
<shortdesc lang="en">CTDB debug level</shortdesc>
<content type="integer" default="${OCF_RESKEY_ctdb_debuglevel_default}" />
</parameter>
<parameter name="ctdb_max_open_files" required="0">
<longdesc lang="en">
Maximum number of open files (for ulimit -n)
</longdesc>
<shortdesc lang="en">Max open files</shortdesc>
<content type="integer" default="${OCF_RESKEY_ctdb_max_open_files_default}" />
</parameter>
<parameter name="smb_conf" unique="0" required="0">
<longdesc lang="en">
Path to default samba config file. Only necessary if CTDB
is managing Samba.
</longdesc>
<shortdesc lang="en">Path to smb.conf</shortdesc>
<content type="string" default="${OCF_RESKEY_smb_conf_default}" />
</parameter>
<parameter name="smb_private_dir" unique="1" required="0">
<longdesc lang="en">
The directory for smbd to use for storing such files as
smbpasswd and secrets.tdb. Old versions of CTBD (prior to 1.0.50)
required this to be on shared storage. This parameter should not
be set for current versions of CTDB, and only remains in the RA
for backwards compatibility.
</longdesc>
<shortdesc lang="en">Samba private dir (deprecated)</shortdesc>
<content type="string" default="${OCF_RESKEY_smb_private_dir_default}" />
</parameter>
<parameter name="smb_passdb_backend" unique="0" required="0">
<longdesc lang="en">
Which backend to use for storing user and possibly group
information. Only necessary if CTDB is managing Samba.
</longdesc>
<shortdesc lang="en">Samba passdb backend</shortdesc>
<content type="string" default="${OCF_RESKEY_smb_passdb_backend_default}" />
</parameter>
<parameter name="smb_idmap_backend" unique="0" required="0">
<longdesc lang="en">
Which backend to use for SID/uid/gid mapping. Only necessary
if CTDB is managing Samba.
</longdesc>
<shortdesc lang="en">Samba idmap backend</shortdesc>
<content type="string" default="${OCF_RESKEY_smb_idmap_backend_default}" />
</parameter>
<parameter name="smb_fileid_algorithm" unique="0" required="0">
<longdesc lang="en">
Which fileid:algorithm to use with vfs_fileid. The correct
value depends on which clustered filesystem is in use, e.g.:
for OCFS2, this should be set to "fsid". Only necessary if
CTDB is managing Samba.
</longdesc>
<shortdesc lang="en">Samba VFS fileid algorithm</shortdesc>
<content type="string" default="${OCF_RESKEY_smb_fileid_algorithm_default}" />
</parameter>
</parameters>
<actions>
<action name="start" timeout="90s" />
<action name="stop" timeout="100s" />
<action name="monitor" timeout="20s" interval="10s" depth="0" />
<action name="meta-data" timeout="5s" />
<action name="validate-all" timeout="30s" />
</actions>
</resource-agent>
END
}
#######################################################################
# Figure out path to /etc/sysconfig/ctdb (same logic as
# loadconfig() from /etc/ctdb/functions
if [ -f /etc/sysconfig/ctdb ]; then
CTDB_SYSCONFIG=/etc/sysconfig/ctdb
elif [ -f /etc/default/ctdb ]; then
CTDB_SYSCONFIG=/etc/default/ctdb
elif [ -f "$OCF_RESKEY_ctdb_config_dir/ctdb" ]; then
CTDB_SYSCONFIG=$OCF_RESKEY_ctdb_config_dir/ctdb
elif [ -f "$OCF_RESKEY_ctdb_config_dir/ctdbd.conf" ]; then
CTDB_SYSCONFIG=$OCF_RESKEY_ctdb_config_dir/ctdbd.conf
fi
# Backup paths
CTDB_SYSCONFIG_BACKUP=${CTDB_SYSCONFIG}.ctdb-ra-orig
invoke_ctdb() {
# CTDB's defaults are:
local timelimit
timelimit=120
# ...but we override with the timeout for the current op:
if [ -n "$OCF_RESKEY_CRM_meta_timeout" ]; then
timelimit=$((OCF_RESKEY_CRM_meta_timeout/1000))
fi
local vers=$(ctdb_version)
ocf_version_cmp "$vers" "4.9.0"
# if version < 4.9.0 specify '--socket' otherwise it's
# a compiled option
if [ "$?" -eq "0" ]; then
$OCF_RESKEY_ctdb_binary --socket="$OCF_RESKEY_ctdb_socket" \
-t ${OCF_RESKEY_ctdb_timeout} -T $timelimit \
"$@"
else
$OCF_RESKEY_ctdb_binary \
-t ${OCF_RESKEY_ctdb_timeout} -T $timelimit \
"$@"
fi
}
# Enable any event scripts that are explicitly required.
# Any others will ultimately be invoked or not based on how they ship
# with CTDB, but will generally have no effect, beacuase the relevant
# CTDB_MANAGES_* options won't be set in /etc/sysconfig/ctdb.
enable_event_scripts_chmod() {
local event_dir
event_dir=$OCF_RESKEY_ctdb_config_dir/events.d
chmod u+x "$event_dir/00.ctdb" # core database health check
if [ -f "${OCF_RESKEY_ctdb_config_dir}/public_addresses" ]; then
chmod u+x "$event_dir/10.interface"
else
chmod a-x "$event_dir/10.interface"
fi
if [ -f "${OCF_RESKEY_ctdb_config_dir}/static-routes" ]; then
chmod u+x "$event_dir/11.routing"
else
chmod a-x "$event_dir/11.routing"
fi
if ocf_is_true "$OCF_RESKEY_ctdb_manages_samba" || \
ocf_is_true "$OCF_RESKEY_ctdb_manages_winbind"; then
chmod u+x "$event_dir/50.samba"
else
chmod a-x "$event_dir/50.samba"
fi
}
enable_event_scripts_symlink() {
# event scripts are symlinked once enabled, with the link source in...
mkdir -p "$OCF_RESKEY_ctdb_config_dir/events/legacy" 2>/dev/null
invoke_ctdb event script enable legacy 00.ctdb
if [ -f "${OCF_RESKEY_ctdb_config_dir}/public_addresses" ]; then
invoke_ctdb event script enable legacy 10.interface
else
invoke_ctdb event script disable legacy 10.interface
fi
if [ -f "${OCF_RESKEY_ctdb_config_dir}/static-routes" ]; then
invoke_ctdb event script enable legacy 11.routing
else
invoke_ctdb event script disable legacy 11.routing
fi
if ocf_is_true "$OCF_RESKEY_ctdb_manages_winbind"; then
invoke_ctdb event script enable legacy 49.winbind
else
invoke_ctdb event script disable legacy 49.winbind
fi
if ocf_is_true "$OCF_RESKEY_ctdb_manages_samba"; then
invoke_ctdb event script enable legacy 50.samba
else
invoke_ctdb event script disable legacy 50.samba
fi
}
# This function has no effect (currently no way to set CTDB_SET_*)
# but remains here in case we need it in future.
set_ctdb_variables() {
rv=$OCF_SUCCESS
set | grep ^CTDB_SET_ | cut -d_ -f3- |
while read v; do
varname=$(echo "$v" | cut -d= -f1)
value=$(echo "$v" | cut -d= -f2)
invoke_ctdb setvar "$varname" "$value" || rv=$OCF_ERR_GENERIC
done || rv=$OCF_ERR_GENERIC
return $rv
}
# Add necessary settings to /etc/samba/smb.conf. In a perfect world,
# we'd be able to generate a new, temporary, smb.conf file somewhere,
# something like:
# include = /etc/samba/smb.conf
# [global]
# clustering = yes
# # ...etc...
# Unfortunately, we can't do this, because there's no way to tell the
# smb init script where the temporary config is, so we just edit
# the default config file.
init_smb_conf() {
# Don't screw around with the config if CTDB isn't managing Samba!
ocf_is_true "$OCF_RESKEY_ctdb_manages_samba" || return 0
# replace these things in smb.conf
local repl
repl='# CTDB-RA:|passdb backend|clustering|idmap backend|idmap config[[:space:]]*\*[[:space:]]*:[[:space:]]*backend|private dir|ctdbd socket'
local private_dir
[ -n "$OCF_RESKEY_smb_private_dir" ] && private_dir="\tprivate dir = $OCF_RESKEY_smb_private_dir\n"
local vfs_fileid
local do_vfs
do_vfs=0
if [ -n "$OCF_RESKEY_smb_fileid_algorithm" ]; then
repl="${repl}|fileid:algorithm|fileid:mapping"
vfs_fileid="\tfileid:algorithm = $OCF_RESKEY_smb_fileid_algorithm\n"
if sed -n '/^[[:space:]]*\[global\]/,/^[[:space:]]*\[/p' $OCF_RESKEY_smb_conf | \
grep -Eq '^[[:space:]]*vfs objects'; then
# vfs objects already specified, will append fileid to existing line
do_vfs=1
else
vfs_fileid="$vfs_fileid\tvfs objects = fileid\n"
fi
fi
# Preserve permissions of smb.conf
local idmap_config
if grep -Eqs '^[[:space:]]*idmap backend[[:space:]]*=' $OCF_RESKEY_smb_conf; then
idmap_config=old
else
idmap_config=new
fi
cp -a "$OCF_RESKEY_smb_conf" "$OCF_RESKEY_smb_conf.$$"
awk '
/^[[:space:]]*\[/ { global = 0 }
/^[[:space:]]*\[global\]/ { global = 1 }
{
if(global) {
if ('$do_vfs' && $0 ~ /^[[:space:]]vfs objects/ && $0 !~ /fileid/) {
print $0" fileid"
} else if ($0 !~ /^[[:space:]]*('"$repl"')/) {
print
}
} else {
print
}
}' "$OCF_RESKEY_smb_conf" | sed "/^[[:space:]]*\[global\]/ a\\
\t# CTDB-RA: Begin auto-generated section (do not change below)\n\
\tpassdb backend = $OCF_RESKEY_smb_passdb_backend\n\
\tclustering = yes\n\
\tctdbd socket = $OCF_RESKEY_ctdb_socket\n$private_dir$vfs_fileid\
\t# CTDB-RA: End auto-generated section (do not change above)" > "$OCF_RESKEY_smb_conf.$$"
if [ "$idmap_config" = "old" ]; then
sed -i "/^[[:space:]]*clustering = yes/ a\\
\tidmap backend = $OCF_RESKEY_smb_idmap_backend" $OCF_RESKEY_smb_conf.$$
else
sed -i "/^[[:space:]]*clustering = yes/ a\\
\tidmap config * : backend = $OCF_RESKEY_smb_idmap_backend" $OCF_RESKEY_smb_conf.$$
fi
dd conv=notrunc,fsync of="$OCF_RESKEY_smb_conf.$$" if=/dev/null >/dev/null 2>&1
mv "$OCF_RESKEY_smb_conf.$$" "$OCF_RESKEY_smb_conf"
}
# Get rid of that section we added
cleanup_smb_conf() {
ocf_is_true "$OCF_RESKEY_ctdb_manages_samba" || return 0
# preserve permissions of smb.conf
cp -a "$OCF_RESKEY_smb_conf" "$OCF_RESKEY_smb_conf.$$"
sed '/# CTDB-RA: Begin/,/# CTDB-RA: End/d' "$OCF_RESKEY_smb_conf" > "$OCF_RESKEY_smb_conf.$$"
mv "$OCF_RESKEY_smb_conf.$$" "$OCF_RESKEY_smb_conf"
}
append_conf() {
local file_path="$1"
shift
[ -n "$2" ] && echo "$1=$2" >> "$file_path"
}
generate_ctdb_config() {
local ctdb_config="$OCF_RESKEY_ctdb_config_dir/ctdb.conf"
# Backup existing config if we're not already using an auto-generated one
grep -qa '# CTDB-RA: Auto-generated' $ctdb_config || cp -p $ctdb_config ${ctdb_config}.ctdb-ra-orig
if [ $? -ne 0 ]; then
ocf_log warn "Unable to backup $ctdb_config to ${ctdb_config}.ctdb-ra-orig"
fi
local log_option="file:$OCF_RESKEY_ctdb_logfile"
if [ "$OCF_RESKEY_ctdb_logfile" = "syslog" ]; then
log_option="syslog"
fi
local start_as_disabled="false"
ocf_is_true "$OCF_RESKEY_ctdb_start_as_disabled" && start_as_disabled="true"
local dbdir_volatile="$OCF_RESKEY_ctdb_dbdir/volatile"
[ -d "$dbdir_volatile" ] || mkdir -p "$dbdir_volatile" 2>/dev/null
local dbdir_persistent="$OCF_RESKEY_ctdb_dbdir/persistent"
[ -d "$dbdir_persistent" ] || mkdir -p "$dbdir_persistent" 2>/dev/null
local dbdir_state="$OCF_RESKEY_ctdb_dbdir/state"
[ -d "$dbdir_state" ] || mkdir -p "$dbdir_state" 2>/dev/null
cat >$ctdb_config <<EOF
# CTDB-RA: Auto-generated
[logging]
location = $log_option
log level = $OCF_RESKEY_ctdb_debuglevel
[cluster]
recovery lock = $OCF_RESKEY_ctdb_recovery_lock
[database]
volatile database directory = $dbdir_volatile
persistent database directory = $dbdir_persistent
state database directory = $dbdir_state
[legacy]
start as disabled = $start_as_disabled
EOF
}
generate_event_script_options() {
local script_options="$OCF_RESKEY_ctdb_config_dir/script.options"
# Backup existing config if we're not already using an auto-generated one
grep -qa '# CTDB-RA: Auto-generated' $script_options || cp -p $script_options ${script_options}.ctdb-ra-orig
if [ $? -ne 0 ]; then
ocf_log warn "Unable to backup $script_options to ${script_options}.ctdb-ra-orig"
fi
cat >$script_options <<EOF
# CTDB-RA: Auto-generated
CTDB_SAMBA_SKIP_SHARE_CHECK=$(ocf_is_true "$OCF_RESKEY_ctdb_samba_skip_share_check" && echo 'yes' || echo 'no')
EOF
append_conf "$script_options" CTDB_SERVICE_SMB $OCF_RESKEY_ctdb_service_smb
append_conf "$script_options" CTDB_SERVICE_NMB $OCF_RESKEY_ctdb_service_nmb
append_conf "$script_options" CTDB_SERVICE_WINBIND $OCF_RESKEY_ctdb_service_winbind
}
# Generate a new, minimal CTDB config file that's just enough
# to get CTDB running as configured by the RA parameters.
generate_ctdb_sysconfig() {
# Backup existing sysconfig if we're not already using an auto-generated one
grep -qa '# CTDB-RA: Auto-generated' $CTDB_SYSCONFIG || cp -p $CTDB_SYSCONFIG $CTDB_SYSCONFIG_BACKUP
if [ $? -ne 0 ]; then
ocf_log warn "Unable to backup $CTDB_SYSCONFIG to $CTDB_SYSCONFIG_BACKUP"
fi
ocf_log info "Generating new $CTDB_SYSCONFIG"
# Note to maintainers and other random hackers:
# Parameters may need to be set here, for CTDB event
# scripts to pick up, or may need to be passed to ctdbd
# when starting, or both. Be careful. The CTDB source
# tree and manpages are your friends. As a concrete
# example, setting CTDB_START_AS_DISABLED here is
# completely useless, as this is actually a command line
# argument for ctdbd; it's not used anywhere else.
cat >$CTDB_SYSCONFIG <<EOF
# CTDB-RA: Auto-generated by ${0}, backup is at $CTDB_SYSCONFIG_BACKUP
CTDB_MONITOR_FREE_MEMORY=$OCF_RESKEY_ctdb_monitor_free_memory
CTDB_SAMBA_SKIP_SHARE_CHECK=$(ocf_is_true "$OCF_RESKEY_ctdb_samba_skip_share_check" && echo 'yes' || echo 'no')
CTDB_MANAGES_SAMBA=$(ocf_is_true "$OCF_RESKEY_ctdb_manages_samba" && echo 'yes' || echo 'no')
CTDB_MANAGES_WINBIND=$(ocf_is_true "$OCF_RESKEY_ctdb_manages_winbind" && echo 'yes' || echo 'no')
EOF
append_conf "$CTDB_SYSCONFIG" CTDB_SERVICE_SMB $OCF_RESKEY_ctdb_service_smb
append_conf "$CTDB_SYSCONFIG" CTDB_SERVICE_NMB $OCF_RESKEY_ctdb_service_nmb
append_conf "$CTDB_SYSCONFIG" CTDB_SERVICE_WINBIND $OCF_RESKEY_ctdb_service_winbind
}
invoke_ctdbd() {
local vers="$1"
+ ocf_move_to_root_cgroup_if_rt_enabled
+
ocf_version_cmp "$vers" "4.9.0"
if [ "$?" -ne "0" ]; then
# With 4.9+, all ctdbd binary parameters are provided as
# config settings
$OCF_RESKEY_ctdbd_binary
return
fi
# Use logfile by default, or syslog if asked for
local log_option
# --logging supported from v4.3.0 and --logfile / --syslog support
# has been removed from newer versions
ocf_version_cmp "$vers" "4.2.14"
if [ "$?" -eq "2" ]; then
log_option="--logging=file:$OCF_RESKEY_ctdb_logfile"
if [ "$OCF_RESKEY_ctdb_logfile" = "syslog" ]; then
log_option="--logging=syslog"
fi
else
log_option="--logfile=$OCF_RESKEY_ctdb_logfile"
if [ "$OCF_RESKEY_ctdb_logfile" = "syslog" ]; then
log_option="--syslog"
fi
fi
# public addresses file (should not be present, but need to set for correctness if it is)
local pub_addr_option
pub_addr_option=""
[ -f "${OCF_RESKEY_ctdb_config_dir}/public_addresses" ] && \
pub_addr_option="--public-addresses=${OCF_RESKEY_ctdb_config_dir}/public_addresses"
# start as disabled
local start_as_disabled
start_as_disabled="--start-as-disabled"
ocf_is_true "$OCF_RESKEY_ctdb_start_as_disabled" || start_as_disabled=""
$OCF_RESKEY_ctdbd_binary \
--reclock="$OCF_RESKEY_ctdb_recovery_lock" \
--nlist="$OCF_RESKEY_ctdb_config_dir/nodes" \
--socket="$OCF_RESKEY_ctdb_socket" \
--dbdir="$OCF_RESKEY_ctdb_dbdir" \
--dbdir-persistent="$OCF_RESKEY_ctdb_dbdir/persistent" \
--event-script-dir="$OCF_RESKEY_ctdb_config_dir/events.d" \
--notification-script="$OCF_RESKEY_ctdb_config_dir/notify.sh" \
--transport=tcp \
$start_as_disabled $log_option $pub_addr_option \
-d "$OCF_RESKEY_ctdb_debuglevel"
}
ctdb_usage() {
cat <<END
usage: $0 {start|stop|monitor|validate-all|meta-data}
Expects to have a fully populated OCF RA-compliant environment set.
END
}
ctdb_start() {
# Do nothing if already running
ctdb_monitor && return $OCF_SUCCESS
# Make sure config is adequate
ctdb_validate
rv=$?
[ $rv -ne 0 ] && return $rv
# Add necessary configuration to smb.conf
init_smb_conf
if [ $? -ne 0 ]; then
ocf_exit_reason "Failed to update $OCF_RESKEY_smb_conf."
return $OCF_ERR_GENERIC
fi
local version=$(ctdb_version)
ocf_version_cmp "$version" "4.9.0"
if [ "$?" -eq "0" ]; then
# prior to 4.9, ctdbd parameters are in sysconfig or passed as
# binary arguments
generate_ctdb_sysconfig
# prior to 4.9, event script enablement without a running
# ctdbd is done by chmoding the scripts directly
enable_event_scripts_chmod
else
# 4.9+ moves all ctdbd parameters to ctdb.conf
generate_ctdb_config
# 4.9+ event script options are in script.options
generate_event_script_options
# 4.9+ event scripts can be enabled with ctdb directly, which
# performs a symlink
enable_event_scripts_symlink
fi
if [ ! -d "$(dirname $OCF_RESKEY_ctdb_logfile)" ]; then
# ensure the logfile's directory exists, otherwise ctdb will fail to start
mkdir -p $(dirname $OCF_RESKEY_ctdb_logfile)
fi
# ensure ctdb's rundir exists, otherwise it will fail to start
mkdir -p $OCF_RESKEY_ctdb_rundir 2>/dev/null
# set nofile ulimit for ctdbd process
if [ -n "$OCF_RESKEY_ctdb_max_open_files" ]; then
ulimit -n "$OCF_RESKEY_ctdb_max_open_files"
fi
# Start her up
invoke_ctdbd "$version"
if [ $? -ne 0 ]; then
# cleanup smb.conf
cleanup_smb_conf
ocf_exit_reason "Failed to execute $OCF_RESKEY_ctdbd_binary."
return $OCF_ERR_GENERIC
else
# Wait a bit for CTDB to stabilize
# (until start times out if necessary)
while true; do
# Initial sleep is intentional (ctdb init script
# has sleep after ctdbd start, but before invoking
# ctdb to talk to it)
sleep 1
status=$(invoke_ctdb status 2>/dev/null)
if [ $? -ne 0 ]; then
# CTDB will be running, kill it before returning
ctdb_stop
ocf_exit_reason "Can't invoke $OCF_RESKEY_ctdb_binary status"
return $OCF_ERR_GENERIC
fi
if ! echo "$status" | grep -qs 'UNHEALTHY (THIS'; then
# Status does not say this node is unhealthy,
# so we're good to go. Do a bit of final
# setup and (hopefully) return success.
set_ctdb_variables
return $?
fi
done
fi
# ctdbd will (or can) actually still be running at this point, so kill it
ctdb_stop
ocf_exit_reason "Timeout waiting for CTDB to stabilize"
return $OCF_ERR_GENERIC
}
ctdb_stop() {
# Do nothing if already stopped
pkill -0 -f "$OCF_RESKEY_ctdbd_binary" || return $OCF_SUCCESS
# Tell it to die nicely
invoke_ctdb shutdown >/dev/null 2>&1
rv=$?
# No more Mr. Nice Guy
count=0
while pkill -0 -f "$OCF_RESKEY_ctdbd_binary" ; do
sleep 1
count=$((count + 1))
[ $count -gt 10 ] && {
ocf_log info "killing ctdbd "
pkill -9 -f "$OCF_RESKEY_ctdbd_binary"
pkill -9 -f "${OCF_RESKEY_ctdb_config_dir}/events"
}
done
# Cleanup smb.conf
cleanup_smb_conf
# It was a clean shutdown, return success
[ $rv -eq $OCF_SUCCESS ] && return $OCF_SUCCESS
# Unclean shutdown, return success if there's no ctdbds left (we
# killed them forcibly, but at least they're good and dead).
pkill -0 -f "$OCF_RESKEY_ctdbd_binary" || return $OCF_SUCCESS
# Problem: ctdb shutdown didn't work and neither did some vigorous
# kill -9ing. Only thing to do is report failure.
return $OCF_ERR_GENERIC
}
ctdb_monitor() {
local status
# "ctdb status" exits non-zero if CTDB isn't running.
# It can also exit non-zero if there's a timeout (ctdbd blocked,
# stalled, massive load, or otherwise wedged). If it's actually
# not running, STDERR will say "Errno:Connection refused(111)",
# whereas if it's wedged, it'll say various other unpleasant things.
status=$(invoke_ctdb status 2>&1)
if [ $? -ne 0 ]; then
if echo "$status" | grep -qs 'Connection refused'; then
return $OCF_NOT_RUNNING
elif echo "$status" | grep -qs 'No such file or directory'; then
return $OCF_NOT_RUNNING
elif echo $status | grep -qs 'connect() failed'; then
return $OCF_NOT_RUNNING
else
ocf_exit_reason "CTDB status call failed: $status"
return $OCF_ERR_GENERIC
fi
fi
if echo "$status" | grep -Eqs '(OK|DISABLED) \(THIS'; then
return $OCF_SUCCESS
fi
ocf_exit_reason "CTDB status is bad: $status"
return $OCF_ERR_GENERIC
}
ctdb_validate() {
# Required binaries
for binary in pkill; do
check_binary $binary
done
if ocf_is_true "$OCF_RESKEY_ctdb_manages_samba" && [ ! -f "$OCF_RESKEY_smb_conf" ]; then
ocf_exit_reason "Samba config file '$OCF_RESKEY_smb_conf' does not exist."
return $OCF_ERR_INSTALLED
fi
if [ -f "${OCF_RESKEY_ctdb_config_dir}/public_addresses" ]; then
ocf_log warn "CTDB file '${OCF_RESKEY_ctdb_config_dir}/public_addresses' exists - CTDB will try to manage IP failover!"
fi
if [ ! -f "$OCF_RESKEY_ctdb_config_dir/nodes" ]; then
ocf_exit_reason "$OCF_RESKEY_ctdb_config_dir/nodes does not exist."
return $OCF_ERR_ARGS
fi
if [ -z "$OCF_RESKEY_ctdb_recovery_lock" ]; then
ocf_exit_reason "ctdb_recovery_lock not specified."
return $OCF_ERR_CONFIGURED
fi
if [ "${OCF_RESKEY_ctdb_recovery_lock:0:1}" == '!' ]; then
# '!' prefix means recovery lock is handled via a helper binary
binary="${OCF_RESKEY_ctdb_recovery_lock:1}"
binary="${binary%% *}" # trim any parameters
if [ -z "$binary" ]; then
ocf_exit_reason "ctdb_recovery_lock invalid helper"
return $OCF_ERR_CONFIGURED
fi
check_binary "${binary}"
else
lock_dir=$(dirname "$OCF_RESKEY_ctdb_recovery_lock")
touch "$lock_dir/$$" 2>/dev/null
if [ $? != 0 ]; then
ocf_exit_reason "Directory for lock file '$OCF_RESKEY_ctdb_recovery_lock' does not exist, or is not writable."
return $OCF_ERR_ARGS
fi
rm "$lock_dir/$$"
fi
return $OCF_SUCCESS
}
case $__OCF_ACTION in
meta-data) meta_data
exit $OCF_SUCCESS
;;
start) ctdb_start;;
stop) ctdb_stop;;
monitor) ctdb_monitor;;
validate-all) ctdb_validate;;
usage|help) ctdb_usage
exit $OCF_SUCCESS
;;
*) ctdb_usage
exit $OCF_ERR_UNIMPLEMENTED
;;
esac
rc=$?
ocf_log debug "${OCF_RESOURCE_INSTANCE} $__OCF_ACTION : $rc"
exit $rc
diff --git a/heartbeat/ocf-shellfuncs.in b/heartbeat/ocf-shellfuncs.in
index 6be4e4e30..2c53a967a 100644
--- a/heartbeat/ocf-shellfuncs.in
+++ b/heartbeat/ocf-shellfuncs.in
@@ -1,1048 +1,1060 @@
#
#
# Common helper functions for the OCF Resource Agents supplied by
# heartbeat.
#
# Copyright (c) 2004 SUSE LINUX AG, Lars Marowsky-Brée
# All Rights Reserved.
#
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# Build version: $Format:%H$
# TODO: Some of this should probably split out into a generic OCF
# library for shell scripts, but for the time being, we'll just use it
# ourselves...
#
# TODO wish-list:
# - Generic function for evaluating version numbers
# - Generic function(s) to extract stuff from our own meta-data
# - Logging function which automatically adds resource identifier etc
# prefixes
# TODO: Move more common functionality for OCF RAs here.
#
# This was common throughout all legacy Heartbeat agents
unset LC_ALL; export LC_ALL
unset LANGUAGE; export LANGUAGE
: ${HA_SBIN_DIR:=@sbindir@}
__SCRIPT_NAME=`basename $0`
if [ -z "$OCF_ROOT" ]; then
: ${OCF_ROOT=@OCF_ROOT_DIR@}
fi
if [ "$OCF_FUNCTIONS_DIR" = ${OCF_ROOT}/resource.d/heartbeat ]; then # old
unset OCF_FUNCTIONS_DIR
fi
: ${OCF_FUNCTIONS_DIR:=${OCF_ROOT}/lib/heartbeat}
. ${OCF_FUNCTIONS_DIR}/ocf-binaries
. ${OCF_FUNCTIONS_DIR}/ocf-returncodes
. ${OCF_FUNCTIONS_DIR}/ocf-directories
. ${OCF_FUNCTIONS_DIR}/ocf-rarun
. ${OCF_FUNCTIONS_DIR}/ocf-distro
# Define OCF_RESKEY_CRM_meta_interval in case it isn't already set,
# to make sure that ocf_is_probe() always works
: ${OCF_RESKEY_CRM_meta_interval=0}
ocf_is_root() {
if [ X`id -u` = X0 ]; then
true
else
false
fi
}
ocf_maybe_random() {
if test -c /dev/urandom; then
od -An -N4 -tu4 /dev/urandom | tr -d '[:space:]'
else
awk -v pid=$$ 'BEGIN{srand(pid); print rand()}' | sed 's/^.*[.]//'
fi
}
# Portability comments:
# o The following rely on Bourne "sh" pattern-matching, which is usually
# that for filename generation (note: not regexp).
# o The "*) true ;;" clause is probably unnecessary, but is included
# here for completeness.
# o The negation in the pattern uses "!". This seems to be common
# across many OSes (whereas the alternative "^" fails on some).
# o If an OS is encountered where this negation fails, then a possible
# alternative would be to replace the function contents by (e.g.):
# [ -z "`echo $1 | tr -d '[0-9]'`" ]
#
ocf_is_decimal() {
case "$1" in
""|*[!0-9]*) # empty, or at least one non-decimal
false ;;
*)
true ;;
esac
}
ocf_is_true() {
case "$1" in
yes|true|1|YES|TRUE|True|ja|on|ON) true ;;
*) false ;;
esac
}
ocf_is_hex() {
case "$1" in
""|*[!0-9a-fA-F]*) # empty, or at least one non-hex
false ;;
*)
true ;;
esac
}
ocf_is_octal() {
case "$1" in
""|*[!0-7]*) # empty, or at least one non-octal
false ;;
*)
true ;;
esac
}
__ocf_set_defaults() {
__OCF_ACTION="$1"
# Return to sanity for the agents...
unset LANG
LC_ALL=C
export LC_ALL
# TODO: Review whether we really should source this. Or rewrite
# to match some emerging helper function syntax...? This imports
# things which no OCF RA should be using...
# Strip the OCF_RESKEY_ prefix from this particular parameter
if [ -z "$OCF_RESKEY_OCF_CHECK_LEVEL" ]; then
: ${OCF_CHECK_LEVEL:=0}
else
: ${OCF_CHECK_LEVEL:=$OCF_RESKEY_OCF_CHECK_LEVEL}
fi
if [ ! -d "$OCF_ROOT" ]; then
ha_log "ERROR: OCF_ROOT points to non-directory $OCF_ROOT."
exit $OCF_ERR_GENERIC
fi
if [ -z "$OCF_RESOURCE_TYPE" ]; then
: ${OCF_RESOURCE_TYPE:=$__SCRIPT_NAME}
fi
if [ "x$__OCF_ACTION" = "xmeta-data" ]; then
: ${OCF_RESOURCE_INSTANCE:="RESOURCE_ID"}
fi
if [ -z "$OCF_RA_VERSION_MAJOR" ]; then
: We are being invoked as an init script.
: Fill in some things with reasonable values.
: ${OCF_RESOURCE_INSTANCE:="default"}
return 0
fi
if [ -z "$OCF_RESOURCE_INSTANCE" ]; then
ha_log "ERROR: Need to tell us our resource instance name."
exit $OCF_ERR_ARGS
fi
}
hadate() {
date "+${HA_DATEFMT}"
}
set_logtag() {
if [ -z "$HA_LOGTAG" ]; then
if [ -n "$OCF_RESOURCE_INSTANCE" ]; then
HA_LOGTAG="$__SCRIPT_NAME($OCF_RESOURCE_INSTANCE)[$$]"
else
HA_LOGTAG="$__SCRIPT_NAME[$$]"
fi
fi
}
__ha_log() {
local ignore_stderr=false
local loglevel
[ "x$1" = "x--ignore-stderr" ] && ignore_stderr=true && shift
[ none = "$HA_LOGFACILITY" ] && HA_LOGFACILITY=""
# if we're connected to a tty, then output to stderr
if tty >/dev/null; then
if [ "x$HA_debug" = "x0" -a "x$loglevel" = xdebug ] ; then
return 0
elif [ "$ignore_stderr" = "true" ]; then
# something already printed this error to stderr, so ignore
return 0
fi
if [ "$HA_LOGTAG" ]; then
echo "$HA_LOGTAG: $*"
else
echo "$*"
fi >&2
return 0
fi
set_logtag
if [ "x${HA_LOGD}" = "xyes" ] ; then
ha_logger -t "${HA_LOGTAG}" "$@"
if [ "$?" -eq "0" ] ; then
return 0
fi
fi
if
[ -n "$HA_LOGFACILITY" ]
then
: logging through syslog
# loglevel is unknown, use 'notice' for now
loglevel=notice
case "${*}" in
*ERROR*) loglevel=err;;
*WARN*) loglevel=warning;;
*INFO*|info) loglevel=info;;
esac
logger -t "$HA_LOGTAG" -p ${HA_LOGFACILITY}.${loglevel} "${*}"
fi
if
[ -n "$HA_LOGFILE" ]
then
: appending to $HA_LOGFILE
echo `hadate`" $HA_LOGTAG: ${*}" >> $HA_LOGFILE
fi
if
[ -z "$HA_LOGFACILITY" -a -z "$HA_LOGFILE" ] && ! [ "$ignore_stderr" = "true" ]
then
: appending to stderr
echo `hadate`"${*}" >&2
fi
if
[ -n "$HA_DEBUGLOG" ]
then
: appending to $HA_DEBUGLOG
if [ "$HA_LOGFILE"x != "$HA_DEBUGLOG"x ]; then
echo "$HA_LOGTAG: "`hadate`"${*}" >> $HA_DEBUGLOG
fi
fi
}
ha_log()
{
__ha_log "$@"
}
ha_debug() {
if [ "x${HA_debug}" = "x0" ] || [ -z "${HA_debug}" ] ; then
return 0
fi
if tty >/dev/null; then
if [ "$HA_LOGTAG" ]; then
echo "$HA_LOGTAG: $*"
else
echo "$*"
fi >&2
return 0
fi
set_logtag
if [ "x${HA_LOGD}" = "xyes" ] ; then
ha_logger -t "${HA_LOGTAG}" -D "ha-debug" "$@"
if [ "$?" -eq "0" ] ; then
return 0
fi
fi
[ none = "$HA_LOGFACILITY" ] && HA_LOGFACILITY=""
if
[ -n "$HA_LOGFACILITY" ]
then
: logging through syslog
logger -t "$HA_LOGTAG" -p "${HA_LOGFACILITY}.debug" "${*}"
fi
if
[ -n "$HA_DEBUGLOG" ]
then
: appending to $HA_DEBUGLOG
echo "$HA_LOGTAG: "`hadate`"${*}" >> $HA_DEBUGLOG
fi
if
[ -z "$HA_LOGFACILITY" -a -z "$HA_DEBUGLOG" ]
then
: appending to stderr
echo "$HA_LOGTAG: `hadate`${*}: ${HA_LOGFACILITY}" >&2
fi
}
ha_parameter() {
local VALUE
VALUE=`sed -e 's%[ ][ ]*% %' -e 's%^ %%' -e 's%#.*%%' $HA_CF | grep -i "^$1 " | sed 's%[^ ]* %%'`
if
[ "X$VALUE" = X ]
then
case $1 in
keepalive) VALUE=2;;
deadtime)
ka=`ha_parameter keepalive`
VALUE=`expr $ka '*' 2 '+' 1`;;
esac
fi
echo $VALUE
}
ocf_log() {
# TODO: Revisit and implement internally.
if
[ $# -lt 2 ]
then
ocf_log err "Not enough arguments [$#] to ocf_log."
fi
__OCF_PRIO="$1"
shift
__OCF_MSG="$*"
case "${__OCF_PRIO}" in
crit) __OCF_PRIO="CRIT";;
err) __OCF_PRIO="ERROR";;
warn) __OCF_PRIO="WARNING";;
info) __OCF_PRIO="INFO";;
debug)__OCF_PRIO="DEBUG";;
*) __OCF_PRIO=`echo ${__OCF_PRIO}| tr '[a-z]' '[A-Z]'`;;
esac
if [ "${__OCF_PRIO}" = "DEBUG" ]; then
ha_debug "${__OCF_PRIO}: $__OCF_MSG"
else
ha_log "${__OCF_PRIO}: $__OCF_MSG"
fi
}
#
# ocf_exit_reason: print exit error string to stderr
# Usage: Allows the OCF script to provide a string
# describing why the exit code was returned.
# Arguments: reason - required, The string that represents why the error
# occured.
#
ocf_exit_reason()
{
local cookie="$OCF_EXIT_REASON_PREFIX"
local fmt
local msg
# No argument is likely not intentional.
# Just one argument implies a printf format string of just "%s".
# "Least surprise" in case some interpolated string from variable
# expansion or other contains a percent sign.
# More than one argument: first argument is going to be the format string.
case $# in
0) ocf_log err "Not enough arguments to ocf_log_exit_msg." ;;
1) fmt="%s" ;;
*) fmt=$1
shift
case $fmt in
*%*) : ;; # ok, does look like a format string
*) ocf_log warn "Does not look like format string: [$fmt]" ;;
esac ;;
esac
if [ -z "$cookie" ]; then
# use a default prefix
cookie="ocf-exit-reason:"
fi
msg=$(printf "${fmt}" "$@")
printf >&2 "%s%s\n" "$cookie" "$msg"
__ha_log --ignore-stderr "ERROR: $msg"
}
#
# ocf_deprecated: Log a deprecation warning
# Usage: ocf_deprecated [param-name]
# Arguments: param-name optional, name of a boolean resource
# parameter that can be used to suppress
# the warning (default
# "ignore_deprecation")
ocf_deprecated() {
local param
param=${1:-ignore_deprecation}
# don't use ${!param} here, it's a bashism
if ! ocf_is_true $(eval echo \$OCF_RESKEY_$param); then
ocf_log warn "This resource agent is deprecated" \
"and may be removed in a future release." \
"See the man page for details." \
"To suppress this warning, set the \"${param}\"" \
"resource parameter to true."
fi
}
#
# Ocf_run: Run a script, and log its output.
# Usage: ocf_run [-q] [-info|-warn|-err] <command>
# -q: don't log the output of the command if it succeeds
# -info|-warn|-err: log the output of the command at given
# severity if it fails (defaults to err)
#
ocf_run() {
local rc
local output
local verbose=1
local loglevel=err
local var
for var in 1 2
do
case "$1" in
"-q")
verbose=""
shift 1;;
"-info"|"-warn"|"-err")
loglevel=`echo $1 | sed -e s/-//g`
shift 1;;
*)
;;
esac
done
output=`"$@" 2>&1`
rc=$?
[ -n "$output" ] && output="$(echo "$output" | tr -s ' \t\r\n' ' ')"
if [ $rc -eq 0 ]; then
if [ "$verbose" -a ! -z "$output" ]; then
ocf_log info "$output"
fi
else
if [ ! -z "$output" ]; then
ocf_log $loglevel "$output"
else
ocf_log $loglevel "command failed: $*"
fi
fi
return $rc
}
ocf_pidfile_status() {
local pid pidfile="$1"
if [ ! -e "$pidfile" ]; then
# Not exists
return 2
fi
pid=$(cat "$pidfile")
kill -0 "$pid" > /dev/null 2>&1
if [ $? = 0 ]; then
return 0
fi
# Stale
return 1
}
# mkdir(1) based locking
# first the directory is created with the name given as $1
# then a file named "pid" is created within that directory with
# the process PID
# stale locks are handled carefully, the inode of a directory
# needs to match before and after test if the process is running
# empty directories are also handled appropriately
# we relax (sleep) occasionally to allow for other processes to
# finish managing the lock in case they are in the middle of the
# business
relax() { sleep 0.5; }
ocf_get_stale_pid() {
local piddir pid dir_inode
piddir="$1"
[ -z "$piddir" ] && return 2
dir_inode="`ls -di $piddir 2>/dev/null`"
[ -z "$dir_inode" ] && return 1
pid=`cat $piddir/pid 2>/dev/null`
if [ -z "$pid" ]; then
# empty directory?
relax
if [ "$dir_inode" = "`ls -di $piddir 2>/dev/null`" ]; then
echo $dir_inode
else
return 1
fi
elif kill -0 $pid >/dev/null 2>&1; then
return 1
elif relax && [ -e "$piddir/pid" ] && [ "$dir_inode" = "`ls -di $piddir 2>/dev/null`" ]; then
echo $pid
else
return 1
fi
}
# There is a race when the following two functions to manage the
# lock file (mk and rm) are invoked in parallel by different
# instances. It is up to the caller to reduce probability of that
# taking place (see ocf_take_lock() below).
ocf_mk_pid() {
mkdir $1 2>/dev/null && echo $$ > $1/pid
}
ocf_rm_pid() {
rm -f $1/pid
rmdir $1 2>/dev/null
}
# Testing and subsequently removing a stale lock (containing the
# process pid) is inherently difficult to do in such a way as to
# prevent a race between creating a pid file and removing it and
# its directory. We reduce the probability of that happening by
# checking if the stale lock persists over a random period of
# time.
ocf_take_lock() {
local lockdir=$1
local rnd
local stale_pid
# we don't want it too short, so strip leading zeros
rnd=$(ocf_maybe_random | sed 's/^0*//')
stale_pid=`ocf_get_stale_pid $lockdir`
if [ -n "$stale_pid" ]; then
sleep 0.$rnd
# remove "stale pid" only if it persists
[ "$stale_pid" = "`ocf_get_stale_pid $lockdir`" ] &&
ocf_rm_pid $lockdir
fi
while ! ocf_mk_pid $lockdir; do
ocf_log info "Sleeping until $lockdir is released..."
sleep 0.$rnd
done
}
ocf_release_lock_on_exit() {
trap "ocf_rm_pid $1" EXIT
}
# returns true if the CRM is currently running a probe. A probe is
# defined as a monitor operation with a monitoring interval of zero.
ocf_is_probe() {
[ "$__OCF_ACTION" = "monitor" -a "$OCF_RESKEY_CRM_meta_interval" = 0 ]
}
# returns true if the resource is configured as a clone. This is
# defined as a resource where the clone-max meta attribute is present.
ocf_is_clone() {
[ ! -z "${OCF_RESKEY_CRM_meta_clone_max}" ]
}
# returns true if the resource is configured as a multistate
# (master/slave) resource. This is defined as a resource where the
# master-max meta attribute is present, and set to greater than zero.
ocf_is_ms() {
[ "${OCF_RESKEY_CRM_meta_promotable}" = "true" ] || { [ ! -z "${OCF_RESKEY_CRM_meta_master_max}" ] && [ "${OCF_RESKEY_CRM_meta_master_max}" -gt 0 ]; }
}
# version check functions
# allow . and - to delimit version numbers
# max version number is 999
#
ocf_is_ver() {
echo $1 | grep '^[0-9][0-9.-]*[0-9A-Za-z.\+-]*$' >/dev/null 2>&1
}
# usage: ocf_version_cmp VER1 VER2
# version strings can contain digits, dots, and dashes
# must start and end with a digit
# returns:
# 0: VER1 smaller (older) than VER2
# 1: versions equal
# 2: VER1 greater (newer) than VER2
# 3: bad format
ocf_version_cmp() {
ocf_is_ver "$1" || return 3
ocf_is_ver "$2" || return 3
local v1=$1
local v2=$2
sort_version="sort -t. -k 1,1n -k 2,2n -k 3,3n -k 4,4n"
older=$( (echo "$v1"; echo "$v2") | $sort_version | head -1 )
if [ "$v1" = "$v2" ]; then
return 1
elif [ "$v1" = "$older" ]; then
return 0
else
return 2 # -1 would look funny in shell ;-)
fi
}
ocf_local_nodename() {
# use crm_node -n for pacemaker > 1.1.8
which pacemakerd > /dev/null 2>&1
if [ $? -eq 0 ]; then
local version=$(pacemakerd -$ | grep "Pacemaker .*" | awk '{ print $2 }')
version=$(echo $version | awk -F- '{ print $1 }')
ocf_version_cmp "$version" "1.1.8"
if [ $? -eq 2 ]; then
which crm_node > /dev/null 2>&1
if [ $? -eq 0 ]; then
crm_node -n
return
fi
fi
fi
# otherwise use uname -n
uname -n
}
# usage: dirname DIR
dirname()
{
local a
local b
[ $# = 1 ] || return 1
a="$1"
while [ 1 ]; do
b="${a%/}"
[ "$a" = "$b" ] && break
a="$b"
done
b=${a%/*}
[ -z "$b" -o "$a" = "$b" ] && b="."
echo "$b"
return 0
}
# usage: systemd_is_running
# returns:
# 0 PID 1 is systemd
# 1 otherwise
systemd_is_running()
{
[ "$(cat /proc/1/comm 2>/dev/null)" = "systemd" ]
}
# usage: systemd_drop_in <name> <After|Before> <dependency.service>
systemd_drop_in()
{
local conf_file
if [ $# -ne 3 ]; then
ocf_log err "Incorrect number of arguments [$#] for systemd_drop_in."
fi
systemdrundir="/run/systemd/system/resource-agents-deps.target.d"
mkdir -p "$systemdrundir"
conf_file="$systemdrundir/$1.conf"
cat >"$conf_file" <<EOF
[Unit]
$2=$3
EOF
# The information is accessible through systemd API and systemd would
# complain about improper permissions.
chmod o+r "$conf_file"
systemctl daemon-reload
}
+# move process to root cgroup if realtime scheduling is enabled
+ocf_move_to_root_cgroup_if_rt_enabled()
+{
+ if [ -e "/sys/fs/cgroup/cpu/cpu.rt_runtime_us" ]; then
+ echo $$ >> /sys/fs/cgroup/cpu/tasks
+
+ if [ "$?" -ne "0" ]; then
+ ocf_log warn "Unable to move PID $$ to the root cgroup"
+ fi
+ fi
+}
+
# usage: crm_mon_no_validation args...
# run crm_mon without any cib schema validation
# This is useful when an agent runs in a bundle to avoid potential
# schema validation errors when host and bundle are not perfectly aligned
# To be used, your shell must support on process substitution (e.g. bash)
# returns:
# <crm_mon error codes>
crm_mon_no_validation()
{
# The subshell prevents parsing error with incompatible shells
"$SHELL" -c "CIB_file=<(${HA_SBIN_DIR}/cibadmin -Q | sed 's/validate-with=\"[^\"]*\"/validate-with=\"none\"/') \
${HA_SBIN_DIR}/crm_mon \$*" -- $*
}
#
# pseudo_resource status tracking function...
#
# This allows pseudo resources to give correct status information. As we add
# resource monitoring, and better resource tracking in general, this will
# become essential.
#
# These scripts work because ${HA_RSCTMP} is cleaned on node reboot.
#
# We create "resource-string" tracking files under ${HA_RSCTMP} in a
# very simple way:
#
# Existence of "${HA_RSCTMP}/resource-string" means that we consider
# the resource named by "resource-string" to be running.
#
# Note that "resource-string" needs to be unique. Using the resource type
# plus the resource instance arguments to make up the resource string
# is probably sufficient...
#
# usage: ha_pseudo_resource resource-string op [tracking_file]
# where op is {start|stop|monitor|status|restart|reload|print}
# print is a special op which just prints the tracking file location
# user can override our choice of the tracking file location by
# specifying it as the third arg
# Note that all operations are silent...
#
ha_pseudo_resource()
{
local ha_resource_tracking_file="${3:-${HA_RSCTMP}/$1}"
case $2 in
start|restart|reload) touch "$ha_resource_tracking_file";;
stop) rm -f "$ha_resource_tracking_file";;
status|monitor)
if
[ -f "$ha_resource_tracking_file" ]
then
return 0
else
case $2 in
status) return 3;;
*) return 7;;
esac
fi;;
print) echo "$ha_resource_tracking_file";;
*) return 3;;
esac
}
# usage: rmtempdir TMPDIR
rmtempdir()
{
[ $# = 1 ] || return 1
if [ -e "$1" ]; then
rmdir "$1" || return 1
fi
return 0
}
# usage: maketempfile [-d]
maketempfile()
{
if [ $# = 1 -a "$1" = "-d" ]; then
mktemp -d
return 0
elif [ $# != 0 ]; then
return 1
fi
mktemp
return 0
}
# usage: rmtempfile TMPFILE
rmtempfile ()
{
[ $# = 1 ] || return 1
if [ -e "$1" ]; then
rm "$1" || return 1
fi
return 0
}
# echo the first lower supported check level
# pass set of levels supported by the agent
# (in increasing order, 0 is optional)
ocf_check_level()
{
local lvl prev
lvl=0
prev=0
if ocf_is_decimal "$OCF_CHECK_LEVEL"; then
# the level list should be very short
for lvl; do
if [ "$lvl" -eq "$OCF_CHECK_LEVEL" ]; then
break
elif [ "$lvl" -gt "$OCF_CHECK_LEVEL" ]; then
lvl=$prev # the previous one
break
fi
prev=$lvl
done
fi
echo $lvl
}
# usage: ocf_stop_processes SIGNALS WAIT_TIME PIDS
#
# we send signals (use quotes for more than one!) in the order
# given; if one or more processes are still running we try KILL;
# the wait_time is the _total_ time we'll spend in this function
# this time may be slightly exceeded if the processes won't leave
#
# returns:
# 0: all processes left
# 1: some processes still running
#
# example:
#
# ocf_stop_processes TERM 5 $pids
#
ocf_stop_processes() {
local signals="$1"
local wait_time="$(($2/`echo $signals|wc -w`))"
shift 2
local pids="$*"
local sig i
test -z "$pids" &&
return 0
for sig in $signals KILL; do
kill -s $sig $pids 2>/dev/null
# try to leave early, and yet leave processes time to exit
sleep 0.2
for i in `seq $wait_time`; do
kill -s 0 $pids 2>/dev/null ||
return 0
sleep 1
done
done
return 1
}
#
# create a given status directory
# if the directory path doesn't start with $HA_VARRUN, then
# we return with error (most of the calls would be with the user
# supplied configuration, hence we need to do necessary
# protection)
# used mostly for PID files
#
# usage: ocf_mkstatedir owner permissions path
#
# owner: user.group
# permissions: permissions
# path: directory path
#
# example:
# ocf_mkstatedir named 755 `dirname $pidfile`
#
ocf_mkstatedir()
{
local owner
local perms
local path
owner=$1
perms=$2
path=$3
test -d $path && return 0
[ $(id -u) = 0 ] || return 1
case $path in
${HA_VARRUN%/}/*) : this path is ok ;;
*) ocf_log err "cannot create $path (does not start with $HA_VARRUN)"
return 1
;;
esac
mkdir -p $path &&
chown $owner $path &&
chmod $perms $path
}
#
# create a unique status directory in $HA_VARRUN
# used mostly for PID files
# the directory is by default set to
# $HA_VARRUN/$OCF_RESOURCE_INSTANCE
# the directory name is printed to stdout
#
# usage: ocf_unique_rundir owner permissions name
#
# owner: user.group (default: "root")
# permissions: permissions (default: "755")
# name: some unique string (default: "$OCF_RESOURCE_INSTANCE")
#
# to use the default either don't set the parameter or set it to
# empty string ("")
# example:
#
# STATEDIR=`ocf_unique_rundir named "" myownstatedir`
#
ocf_unique_rundir()
{
local path
local owner
local perms
local name
owner=${1:-"root"}
perms=${2:-"755"}
name=${3:-"$OCF_RESOURCE_INSTANCE"}
path=$HA_VARRUN/$name
if [ ! -d $path ]; then
[ $(id -u) = 0 ] || return 1
mkdir -p $path &&
chown $owner $path &&
chmod $perms $path || return 1
fi
echo $path
}
#
# RA tracing may be turned on by setting OCF_TRACE_RA
# the trace output will be saved to OCF_TRACE_FILE, if set, or
# by default to
# $HA_VARLIB/trace_ra/<type>/<id>.<action>.<timestamp>
# e.g. $HA_VARLIB/trace_ra/oracle/db.start.2012-11-27.08:37:08
#
# OCF_TRACE_FILE:
# - FD (small integer [3-9]) in that case it is up to the callers
# to capture output; the FD _must_ be open for writing
# - absolute path
#
# NB: FD 9 may be used for tracing with bash >= v4 in case
# OCF_TRACE_FILE is set to a path.
#
ocf_bash_has_xtracefd() {
[ -n "$BASH_VERSION" ] && [ ${BASH_VERSINFO[0]} -ge 4 ]
}
# for backwards compatibility
ocf_is_bash4() {
ocf_bash_has_xtracefd
}
ocf_trace_redirect_to_file() {
local dest=$1
if ocf_bash_has_xtracefd; then
exec 9>$dest
BASH_XTRACEFD=9
else
exec 2>$dest
fi
}
ocf_trace_redirect_to_fd() {
local fd=$1
if ocf_bash_has_xtracefd; then
BASH_XTRACEFD=$fd
else
exec 2>&$fd
fi
}
__ocf_test_trc_dest() {
local dest=$1
if ! touch $dest; then
ocf_log warn "$dest not writable, trace not going to happen"
__OCF_TRC_DEST=""
__OCF_TRC_MANAGE=""
return 1
fi
return 0
}
ocf_default_trace_dest() {
tty >/dev/null && return
if [ -n "$OCF_RESOURCE_TYPE" -a \
-n "$OCF_RESOURCE_INSTANCE" -a -n "$__OCF_ACTION" ]; then
local ts=`date +%F.%T`
__OCF_TRC_DEST=${OCF_RESKEY_trace_dir}/${OCF_RESOURCE_TYPE}/${OCF_RESOURCE_INSTANCE}.${__OCF_ACTION}.$ts
__OCF_TRC_MANAGE="1"
fi
}
ocf_start_trace() {
export __OCF_TRC_DEST="" __OCF_TRC_MANAGE=""
case "$OCF_TRACE_FILE" in
[3-9]) ocf_trace_redirect_to_fd "$OCF_TRACE_FILE" ;;
/*/*) __OCF_TRC_DEST=$OCF_TRACE_FILE ;;
"") ocf_default_trace_dest ;;
*)
ocf_log warn "OCF_TRACE_FILE must be set to either FD (open for writing) or absolute file path"
ocf_default_trace_dest
;;
esac
if [ "$__OCF_TRC_DEST" ]; then
mkdir -p `dirname $__OCF_TRC_DEST`
__ocf_test_trc_dest $__OCF_TRC_DEST ||
return
ocf_trace_redirect_to_file "$__OCF_TRC_DEST"
fi
if [ -n "$BASH_VERSION" ]; then
PS4='+ `date +"%T"`: ${FUNCNAME[0]:+${FUNCNAME[0]}:}${LINENO}: '
fi
set -x
env=$( echo; printenv | sort )
}
ocf_stop_trace() {
set +x
}
# Helper functions to map from nodename/bundle-name and physical hostname
# list_index_for_word "node0 node1 node2 node3 node4 node5" node4 --> 5
# list_word_at_index "NA host1 host2 host3 host4 host5" 3 --> host2
# list_index_for_word "node1 node2 node3 node4 node5" node7 --> ""
# list_word_at_index "host1 host2 host3 host4 host5" 8 --> ""
# attribute_target node1 --> host1
list_index_for_word() {
echo $1 | tr ' ' '\n' | awk -v x="$2" '$0~x {print NR}'
}
list_word_at_index() {
echo $1 | tr ' ' '\n' | awk -v n="$2" 'n == NR'
}
ocf_attribute_target() {
if [ x$1 = x ]; then
if [ x$OCF_RESKEY_CRM_meta_container_attribute_target = xhost -a x$OCF_RESKEY_CRM_meta_physical_host != x ]; then
echo $OCF_RESKEY_CRM_meta_physical_host
else
if [ x$OCF_RESKEY_CRM_meta_on_node != x ]; then
echo $OCF_RESKEY_CRM_meta_on_node
else
ocf_local_nodename
fi
fi
return
elif [ x"$OCF_RESKEY_CRM_meta_notify_all_uname" != x ]; then
index=$(list_index_for_word "$OCF_RESKEY_CRM_meta_notify_all_uname" $1)
mapping=""
if [ x$index != x ]; then
mapping=$(list_word_at_index "$OCF_RESKEY_CRM_meta_notify_all_hosts" $index)
fi
if [ x$mapping != x -a x$mapping != xNA ]; then
echo $mapping
return
fi
fi
echo $1
}
__ocf_set_defaults "$@"
: ${OCF_TRACE_RA:=$OCF_RESKEY_trace_ra}
: ${OCF_RESKEY_trace_dir:="$HA_VARLIB/trace_ra"}
ocf_is_true "$OCF_TRACE_RA" && ocf_start_trace
# pacemaker sets HA_use_logd, some others use HA_LOGD :/
if ocf_is_true "$HA_use_logd"; then
: ${HA_LOGD:=yes}
fi

File Metadata

Mime Type
text/x-diff
Expires
Tue, Feb 25, 8:40 AM (1 d, 17 h)
Storage Engine
blob
Storage Format
Raw Data
Storage Handle
1435517
Default Alt Text
(62 KB)

Event Timeline